/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// Author: jmarantz@google.com (Joshua Marantz)

#include "net/instaweb/util/public/file_writer.h"

#include "net/instaweb/util/public/file_system.h"
#include "net/instaweb/util/public/string_util.h"

namespace net_instaweb {

class MessageHandler;

FileWriter::~FileWriter() {
}

bool FileWriter::Write(const StringPiece& str, MessageHandler* handler) {
  return file_->Write(str, handler);
}

bool FileWriter::Flush(MessageHandler* message_handler) {
  return file_->Flush(message_handler);
}

}  // namespace net_instaweb
